.386
.model flat,stdcall
option casemap:none

include DrawProgress.inc
include Function.asm
.code

; DrawProgress library by Faiseur.

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
    push    hInst
    pop     hInstance
	invoke CreateClass
    mov     eax,TRUE
    ret
DllEntry Endp

;Used by RadASM 2.1.0.4
GetDefEx proc nInx:DWORD
	mov		eax,nInx
	.if !eax
		;Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_BMP
		mov		ccdefex.hbmp,eax
		;Return pointer to inited struct
		mov		eax,offset ccdefex
	.else
		xor		eax,eax
	.endif
	ret
GetDefEx endp

CreateClass proc
	LOCAL	wc:WNDCLASSEX

	;Create a windowclass for the user control
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS or CS_PARENTDC or CS_DBLCLKS
	mov		wc.lpfnWndProc,offset ControlProc
	mov		eax,NULL
	mov		wc.cbClsExtra,eax
	mov		wc.cbWndExtra,4
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,eax
	mov		wc.lpszMenuName,eax
	mov		wc.lpszClassName,offset szClassName
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret
CreateClass endp

;--------------------------------------------------------------------------------


ControlProc proc uses ebx,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ps:PAINTSTRUCT
	LOCAL	rect:RECT
	LOCAL	hdc:HDC
	LOCAL 	tmpFont  :LOGFONT

	Switch uMsg
	Case WM_CREATE
		invoke GetProcessHeap
		invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof PROGRESSDATA
		mov		ebx,eax
		invoke SetWindowLong,hWin,0,ebx
		mov [ebx].PROGRESSDATA.count,0
		fn lstrcpyn, addr buffer,"text",sizeof buffer
		
	Case WM_DESTROY
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		invoke GetProcessHeap
		invoke HeapFree,eax,0,ebx
	Case WM_PAINT
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		mov hdc,FUNC (BeginPaint,hWin,addr ps)
		invoke	GetClientRect,hWin,addr rect
		cmp		ps.fErase,0
		je		@F 
		.if [ebx].PROGRESSDATA.state == FALSE
			invoke	GetSysColorBrush,COLOR_BTNFACE
			invoke	FillRect,hdc,addr rect,eax
		.endif
	@@:
		invoke GetWindowLong,hWin,GWL_STYLE
		and		eax,3
		.if eax==0 ; Blue
			mov		[ebx].PROGRESSDATA.modelcolor,0
		.elseif eax==1 ; Red
			mov		[ebx].PROGRESSDATA.modelcolor,1
		.elseif eax==2 ; Green
			mov		[ebx].PROGRESSDATA.modelcolor,2
		.else	; Light Blue
			mov		[ebx].PROGRESSDATA.modelcolor,3
		.endif
		invoke GetWindowLong,hWin,GWL_STYLE
		and		eax,12
		.if eax==0 ; No text
			mov		[ebx].PROGRESSDATA.modeltext,0
		.elseif eax==4 ;show text
			mov		[ebx].PROGRESSDATA.modeltext,1
		.else  ; show percent
			mov		[ebx].PROGRESSDATA.modeltext,2
		.endif		
		; hdc,hFont,height,count,maxi,left,top,model color,text setting,text string
		invoke DrawProgress,hdc,[ebx].PROGRESSDATA.hFont,rect.bottom,[ebx].PROGRESSDATA.count,[ebx].PROGRESSDATA.maxi,1,1,[ebx].PROGRESSDATA.modelcolor,[ebx].PROGRESSDATA.modeltext,addr buffer
		invoke	EndPaint,hWin,addr ps
	
	Case DP_INIT ; wParam = count / lParam = maxi
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		m2m [ebx].PROGRESSDATA.count,wParam
		m2m [ebx].PROGRESSDATA.maxi, lParam		
		mov [ebx].PROGRESSDATA.state,FALSE
		invoke InvalidateRect,hWin,0,FALSE
	;	invoke RedrawWindow,hWin,0,0,RDW_ERASE or RDW_INVALIDATE

	Case DP_COUNT ; wParam = count / lParam = text (optional)
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		.if lParam != 0
			fn lstrcpyn, addr buffer,lParam,sizeof buffer	
		.endif
		m2m [ebx].PROGRESSDATA.count,wParam
		mov [ebx].PROGRESSDATA.state,TRUE
		invoke InvalidateRect,hWin,0,FALSE	
		
	Case DP_TEXT ; wParam = text
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		.if wParam != 0
			fn lstrcpyn, addr buffer,wParam,sizeof buffer	
		.endif	
			
	Case DP_FONT ; wParam = font
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		.if wParam != 0
			m2m [ebx].PROGRESSDATA.hFont,wParam
		.endif
	
	Endsw
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret

ControlProc endp

End DllEntry
